
#include "Joint.h"

using namespace std;


Joint::Joint(JointT this_joint)
{
	joint = this_joint;
	ang = 0;
	this_ang = 0;
	last_ang = 0;
	last_ang2 = 0;
	WM = WorldModel::getSingleton();
	Log = Logger::getSingleton();
	ACT = ActHandler::getSingleton();
	AS = AgentSettings::getSingleton();
}

Joint::~Joint()
{
	joint = JID_ILLEGAL;
}

double Joint::getT_i(double K_p)
{
	if(K_p == 10)
		return 1000;
	else if(K_p == 20)
		return 800;
	else if(K_p == 30)
		return 400;
	else if(K_p == 40)
		return 1000;
	else if(K_p == 50)
		return 900;
	else if(K_p == 60)
		return 1000;
	else if(K_p == 70)
		return 1000;
	else if(K_p == 80)
		return 500;
	else if(K_p == 90)
		return 500;
//	else if(K_p == 100)
//		return ;
}

bool Joint::initial(JointT this_joint 	)
{
	joint = this_joint;
	return true;

}

double Joint::getT_d(double K_p)
{
	if(K_p == 10)
		return 0.0001;
	else if(K_p == 20)
		return 0.0001;
	else if(K_p == 30)
		return 0.1;
	else if(K_p == 40)
		return 0.01;
	else if(K_p == 50)
		return 0.01;
	else if(K_p == 60)
		return 0.1;
	else if(K_p == 70)
		return 0.00001;
	else if(K_p == 80)
		return 0.00001;
	else if(K_p == 90)
		return 0.01;
//	else if(K_p == 100)
//		return ;
}
//double Joint::getAngle()
//{
//	return Value;
//}

//void Joint::setAngle(double value ,double currentAngle ,double ang)
//{
//	if(c >= 2)
//		last_value1 = this_value;
//
//	Value = value - (currentAngle + last_value1);
//	this_value = ang;
//	c++;
//	return ;
//}

double Joint::getCurrentAngle()
{
	return CurrentAngle;
}

void Joint::setCurrentAngle()
{
	const TSceneJoint* j = WM->getJoint(joint);
	if (!j)
	{
		Log->log(7, "joint does not exist");
		return;
	}
	CurrentAngle = j->getCurrentAngle();
	return;
}



//////////////////////////////////////////////////////////////////////////////////////
//																					//
//////////////////////////////////////////////////////////////////////////////////////




bool Joint::setAngle(double value , double gain , double error)//joint nagire
{
	cout<<"hashem = "<<joint<<endl;
	if(error == -1)
		error = 1.5;//AS->getMaxJointError();//todo

	double k_p = gain /100;
	setCurrentAngle();
	ang = k_p * (value -( CurrentAngle + last_ang + last_ang2));

	if(fabs(ang)  >  6)//todo
		ang = 6 *sign(ang);


	if (fabs(value - CurrentAngle - last_ang - last_ang2) > error)//*gain
	{
		this_ang = ang;
		return false;
	}
	else
	{
		return true;
	}
}

bool Joint::adjustJoint( )
{
	if (this_ang == UnknownDoubleValue || joint == JID_ILLEGAL)
	{
		this_ang = 0;
		return false;
	}
	ACT->putCommandInQueue(SoccerCommand(CMD_JOINT, joint, this_ang));
	last_ang2 = last_ang;
	last_ang = this_ang;
	this_ang = 0;
	return true;
}



//
//bool Joint::setAngle(double value , double gain , double error)//joint nagire
//{
//	if(error == -1)
//		error = AS->getMaxJointError();//todo
//	last_ang = this_ang;
//	double k_p = gain /100;
//	setCurrentAngle();
//	ang = k_p * (value -( CurrentAngle + last_ang ));
//
//
//	if(fabs(ang)  >  6)//todo
//		ang = 6 *sign(ang);
//
//	this_ang = ang;
//
//	if (fabs(value - CurrentAngle) > error)//*gain
//	{
//		adjustJoint(ang);
//		return false;//adjeustjoint
//	}
//	else
//	{
//		return true;
//	}
//}
//
//bool Joint::adjustJoint( double dSpeed)
//{
//	if (dSpeed == UnknownDoubleValue || joint == JID_ILLEGAL)
//		return false;
//	ACT->putCommandInQueue(SoccerCommand(CMD_JOINT, joint, dSpeed));
//	return true;
//}


//////////////////////////////////////////////////////////////////////////////////////
//																					//
//////////////////////////////////////////////////////////////////////////////////////
double Joint::getSentAngle()
{
	return ang;
}

double Joint::getLast_ang()
{
	return temp;
}
